using System;
using System.Runtime.InteropServices;

namespace WindowsApplication1
{
	[AttributeUsage(AttributeTargets.Class | AttributeTargets.Method)]
	public class DeveloperAttribute : System.Attribute
	{
		private string _name;
		private string _email;
		private string _mobile = string.Empty;

		public DeveloperAttribute(string name,string email)
		{
			_name = name;
			_email = email;
		}

		public string Mobile
		{
			get { return _mobile; }
			set { _mobile = value; }
		}

		public override string ToString()
		{
			return string.Format("{0} : {1} {2} {3}",GetType().Name,_name,_email,Mobile);
		}
	}

	[Developer("Jim","jim@falafelsoft.com",Mobile = "07905 165112")]
	public class BaseBeerForJim
	{
		public BaseBeerForJim()
		{
		}
	}


	//[Obsolete("Don't drink bad beer!",true)]
	public class BadBeer : BaseBeerForJim
	{
		[DllImport("KERNEL32.DLL")]
		public static extern bool MoveFile(String src, String dst);
	}

	[Serializable]
	public class GoodBeer : BaseBeerForJim
	{
		[Developer("Jim","jim@falafelsoft.com",Mobile = "07905 165112")]
		public virtual void OrderBeerForJim(int Quantity)
		{
			if (Quantity < 4)
			{
				throw new Exception("You cheapskate bastard!");
			}
		}

		[Obsolete]
		public string TestField;

		private int _testInt;
		[property: Obsolete]
		public int TestInt
		{
			get { return _testInt; }
			set { _testInt = value; }
		}
	}
}


